﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridExportIndentationCase
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            List<SampleData> data = new List<SampleData>();

            for(int i=0; i<10; i++)
            {
                string parentString = "Parent " + i.ToString();
                SampleData sd = new SampleData() { ID = i, Label = parentString, Number = r.Next(1000), Date = DateTime.Today.AddDays(i) };
                sd.Children = new List<ChildData>();

                for(int j=0; j<4; j++)
                {
                    ChildData cd = new ChildData()
                    {
                        ChildID = j,
                        ChildLabel = parentString + ", Child " + j.ToString(),
                        ChildNumber1 = r.Next(100),
                        ChildNumber2 = r.Next(100),
                        ChildNumber3 = r.Next(100),
                        ChildNumber4 = r.Next(100),
                        ChildNumber5 = r.Next(100)
                    };

                    sd.Children.Add(cd);
                }

                data.Add(sd);
            }

            ultraGrid1.DataSource = data;

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            string fileName = "demo.xlsx";

            if (File.Exists(fileName))
            {
                File.Delete(fileName);
            }

            ultraGridExcelExporter1.RowExporting += UltraGridExcelExporter1_RowExporting;
            ultraGridExcelExporter1.HeaderRowExporting += UltraGridExcelExporter1_HeaderRowExporting;

            ultraGridExcelExporter1.Export(ultraGrid1, fileName);
            Process.Start(fileName);
        }

        private void UltraGridExcelExporter1_HeaderRowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventArgs e)
        {
            if (e.GridRow.Band.Key == "Children")
            {
                e.CurrentColumnIndex = 8;
            }
        }

        private void UltraGridExcelExporter1_RowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportingEventArgs e)
        {
            if(e.GridRow.Band.Key == "Children")
            {
                e.CurrentColumnIndex = 8;
            }
        }
    }

    public class SampleData
    {
        public int ID { get; set; }
        public string Label { get; set; }
        public int Number { get; set; }
        public DateTime Date { get; set; }

        public List<ChildData> Children { get; set; }
    }

    public class ChildData
    {
        public int ChildID { get; set; }
        public string ChildLabel { get; set; }
        public int ChildNumber1 { get; set; }
        public int ChildNumber2 { get; set; }
        public int ChildNumber3 { get; set; }
        public int ChildNumber4 { get; set; }
        public int ChildNumber5 { get; set; }
    }
}
